﻿//////////////////////////////////////////////////////////////////
//
// Объект-помощник для приемочного и юнит-тестирования
//
//////////////////////////////////////////////////////////////////

#Использовать asserts
#Использовать tempfiles
#Использовать delegate
#Использовать fs

Перем Пути;
Перем КомандаЗапуска;
Перем НаборТестов;
Перем РезультатТестирования;

Перем ПутьЛогФайлаJUnit;
Перем ФорматыЛогФайла;
Перем ФорматЛогФайла;

Перем НомерТестаДляЗапуска;
Перем НаименованиеТестаДляЗапуска;

Перем Рефлектор;

Перем ЗначенияСостоянияТестов;
Перем СтруктураПараметровЗапуска;

Перем	НаборОшибок;
Перем	НаборНереализованныхТестов;

Перем	ВсегоТестов;
Перем	ВыводитьОшибкиПодробно;

Перем	Лог;

Перем МенеджерВременныхФайлов;

// Для поддержки добавления тестов при помощи метода ДобавитьТест()
Перем ВремМассивТестовыхСлучаев;

Перем ИспользоватьСборСтатистикиСкриптовOnescript;
Перем КаталогСбораСтатистики;

//////////////////////////////////////////////////////////////////////////////
// Программный интерфейс
//

// Получаю версию продукта
//
//  Возвращаемое значение:
//   Строка - номер версии в формате "1.2"
//
Функция Версия() Экспорт
	Возврат Константы_1testrunner.ВерсияПродукта;
КонецФункции // Версия()

// Получить имя лога продукта
//
// Возвращаемое значение:
//  Строка   - имя лога продукта
//
Функция ИмяЛога() Экспорт
	Возврат "oscript.lib.1testrunner";
КонецФункции

Процедура ПодробныеОписанияОшибок(Знач ВключитьПодробноеОписание) Экспорт
	ВыводитьОшибкиПодробно = ВключитьПодробноеОписание;
КонецПроцедуры

Процедура ТестПройден() Экспорт
КонецПроцедуры

Процедура ТестПровален(ДопСообщениеОшибки) Экспорт
	СообщениеОшибки = "Тест провален." + ФорматДСО(ДопСообщениеОшибки);
	ВызватьИсключение(СообщениеОшибки);
КонецПроцедуры

// Включить сбор статистики и покрытия кода для передачи в вызываемые команды запуска oscript
//
Процедура ВключитьСборСтатистикиСкриптовOnescript(Знач ПарамКаталогСбораСтатистики) Экспорт
	ИспользоватьСборСтатистикиСкриптовOnescript = Истина;
	КаталогСбораСтатистики = ПарамКаталогСбораСтатистики;
КонецПроцедуры

// Использовать сбор статистики скриптов Onescript
//
//  Возвращаемое значение:
//   Булево -
//
Функция ИспользоватьСборСтатистикиСкриптовOnescript() Экспорт
	Возврат ИспользоватьСборСтатистикиСкриптовOnescript;
КонецФункции

// Получить каталог сбора статистики скриптов Onescript
//
//  Возвращаемое значение:
//   Файл, Неопределено - каталог сбора статистики или Неопределено, если статистика не собирается
//
Функция КаталогСбораСтатистикиСкриптовOnescript() Экспорт
	Возврат КаталогСбораСтатистики;
КонецФункции

// Включить отладку в логах запускаемых скриптов Onescript
//
Процедура ВключитьОтладкуВЛогахЗапускаемыхСкриптовOnescript() Экспорт
	УстановитьПеременнуюСреды("LOGOS_LEVEL", "DEBUG");
КонецПроцедуры

// Выключить отладку в логах запускаемых скриптов Onescript
//
Процедура ВыключитьОтладкуВЛогахЗапускаемыхСкриптовOnescript() Экспорт
	УстановитьПеременнуюСреды("LOGOS_LEVEL", "");
КонецПроцедуры
// }

// { временные файлы
Функция ИмяВременногоФайла(Знач Расширение = "tmp") Экспорт
	Возврат МенеджерВременныхФайлов.НовоеИмяФайла(Расширение);
КонецФункции

Процедура УдалитьВременныеФайлы() Экспорт
	МенеджерВременныхФайлов.Удалить();
КонецПроцедуры
// }

// { Выполнение тестов - экспортные методы

// Выполняет команду продукта по параметрам командной строки
//
// Параметры:
//   МассивПараметров - Массив - массив аргументов командной строки, аналогично АргументыКоманднойСтроки
//
Процедура ВыполнитьКоманду(Знач МассивПараметров) Экспорт
	Сообщить("1testrunner, ver. " + Версия());

	РезультатТестирования = ЗначенияСостоянияТестов.НеВыполнялся;

	Если Не ОбработатьПараметрыЗапуска(МассивПараметров) Тогда
		РезультатТестирования = ЗначенияСостоянияТестов.НеВыполнялся;
	КонецЕсли;
	УдалитьВременныеФайлы();
КонецПроцедуры

// Тестировать единичный файл теста
//
// Параметры:
//   ФайлТеста - Файл
//   ЛогФайлJUnit - Файл
//   НаименованиеТестаДляЗапуска - Строка - для запуска единственного теста из указанного файла
//   НомерТестаДляЗапуска - Число или Неопределено - для запуска единственного теста из указанного файла
//
//  Возвращаемое значение:
//   Строка - Результат тестирования
//
Функция ТестироватьФайл(Знач ФайлТеста, Знач ЛогФайлJUnit = Неопределено,
		Знач НаименованиеТестаДляЗапуска = Неопределено, Знач НомерТестаДляЗапуска = Неопределено) Экспорт

	ПутьФайлаТеста = ФайлТеста.ПолноеИмя;
	УстановитьПутьЛогФайлаJUnit(ЛогФайлJUnit);

	ПроверитьСуществованиеФайла(ПутьФайлаТеста);

	КомандаЗапуска = СтруктураПараметровЗапуска.Запустить;

	Пути.Добавить(ПутьФайлаТеста);
	Лог.Отладка("Файл теста %1", ПутьФайлаТеста);

	ЗагрузитьТесты();

	ВыполнитьВсеТесты();

	СообщитьСтатусТестирования();

	Возврат РезультатТестирования;

КонецФункции // ТестироватьФайл

// Тестировать каталог тестов
//
// Параметры:
//   КаталогТестов - Файл
//   ЛогФайлJUnit - Файл
//
//  Возвращаемое значение:
//   Строка - Результат тестирования
//
Функция ТестироватьКаталог(Знач КаталогТестов, Знач ЛогФайлJUnit = Неопределено) Экспорт

	ПутьКаталогаТестов = КаталогТестов.ПолноеИмя;
	УстановитьПутьЛогФайлаJUnit(ЛогФайлJUnit);

	ПроверитьСуществованиеФайла(ПутьКаталогаТестов);

	КомандаЗапуска = СтруктураПараметровЗапуска.ЗапуститьКаталог;

	Лог.Отладка("Каталог тестов %1", ПутьКаталогаТестов);

	Файлы = НайтиФайлы(ПутьКаталогаТестов, "*.os");
	Для Каждого Файл Из Файлы Цикл
		Если Файл.ИмяБезРасширения <> "testrunner" Тогда
			Пути.Добавить(Файл.ПолноеИмя);
			Лог.Отладка("Файл теста %1", Файл.ПолноеИмя);
		КонецЕсли;
	КонецЦикла;

	ЗагрузитьТесты();

	ВыполнитьВсеТесты();

	СообщитьСтатусТестирования();

	Возврат РезультатТестирования;

КонецФункции // ТестироватьКаталог

// Получить результат тестирования
//
//  Возвращаемое значение:
//   Строка - Результат тестирования
//
Функция ПолучитьРезультатТестирования() Экспорт
	Возврат РезультатТестирования;
КонецФункции

// }

Функция ПолучитьПараметрыЗапуска(МассивПараметров) Экспорт
	Перем ПутьЛогФайла;

	Если МассивПараметров.Количество() = 0 Тогда
		Лог.Отладка("Не заданы параметры запуска 1testrunner.");
		Возврат Неопределено;
	КонецЕсли;

	НомерТестаДляЗапуска = Неопределено;
	НаименованиеТестаДляЗапуска = Неопределено;
	ПутьЛогФайла = Неопределено;

	НомерПараметраПутьКТестам = -1;

	КомандаЗапуска = НРег(МассивПараметров[0]);
	Если КомандаЗапуска = СтруктураПараметровЗапуска.ПоказатьСписок Тогда
		ПутьКТестам = МассивПараметров[1];
	ИначеЕсли КомандаЗапуска = СтруктураПараметровЗапуска.Запустить
			Или КомандаЗапуска = СтруктураПараметровЗапуска.ЗапуститьКаталог Тогда
		НомерПараметраПутьКТестам = 1;

	Иначе
		КомандаЗапуска = СтруктураПараметровЗапуска.Запустить;
		НомерПараметраПутьКТестам = 0;
	КонецЕсли;

	НомерОчередногоПараметра = НомерПараметраПутьКТестам;

	Если КомандаЗапуска = СтруктураПараметровЗапуска.Запустить Тогда
		ПутьКТестам = МассивПараметров[НомерПараметраПутьКТестам];
		НомерОчередногоПараметра = НомерОчередногоПараметра + 1;
		Если МассивПараметров.Количество() > НомерОчередногоПараметра Тогда
			НомерОчередногоПараметра = НомерПараметраПутьКТестам + 1;
			ИД_Теста = МассивПараметров[НомерОчередногоПараметра];

			Если НРег(ИД_Теста) <> СтруктураПараметровЗапуска.Режим_ПутьЛогФайла Тогда
				Если ВСтрокеСодержатсяТолькоЦифры(ИД_Теста) Тогда
					НомерТестаДляЗапуска = Число(ИД_Теста);
				Иначе
					НаименованиеТестаДляЗапуска = ИД_Теста;
				КонецЕсли;
			КонецЕсли;
		КонецЕсли;
	ИначеЕсли КомандаЗапуска = СтруктураПараметровЗапуска.ЗапуститьКаталог Тогда
		ПутьКТестам = МассивПараметров[НомерПараметраПутьКТестам];
		НомерОчередногоПараметра = НомерОчередногоПараметра + 1;
	КонецЕсли;

	Если МассивПараметров.Количество() > НомерОчередногоПараметра
			И (КомандаЗапуска = СтруктураПараметровЗапуска.Запустить
				ИЛИ КомандаЗапуска = СтруктураПараметровЗапуска.ЗапуститьКаталог ) Тогда
		Режим = НРег(МассивПараметров[НомерОчередногоПараметра]);
		Если Режим = СтруктураПараметровЗапуска.Режим_ПутьЛогФайла Тогда
			Если МассивПараметров.Количество() > НомерОчередногоПараметра + 1 Тогда
				НомерОчередногоПараметра = НомерОчередногоПараметра + 1;
				ПутьЛогФайла = МассивПараметров[НомерОчередногоПараметра];
			КонецЕсли;
		КонецЕсли;
	КонецЕсли;

	ПараметрыЗапуска = Новый Структура;
	ПараметрыЗапуска.Вставить("Команда", КомандаЗапуска);
	ПараметрыЗапуска.Вставить("ПутьКТестам", ПутьКТестам);
	ПараметрыЗапуска.Вставить("НаименованиеТестаДляЗапуска", НаименованиеТестаДляЗапуска);
	ПараметрыЗапуска.Вставить("НомерТестаДляЗапуска", НомерТестаДляЗапуска);
	ПараметрыЗапуска.Вставить("ПутьЛогФайлаJUnit", ПутьЛогФайла);

	Лог.Отладка("Команда %1", КомандаЗапуска);
	Лог.Отладка("ПутьКТестам %1", ПутьКТестам);
	Лог.Отладка("НаименованиеТестаДляЗапуска %1", НаименованиеТестаДляЗапуска);
	Лог.Отладка("НомерТестаДляЗапуска %1", НомерТестаДляЗапуска);
	Лог.Отладка("ПутьЛогФайлаJUnit %1", ПутьЛогФайлаJUnit);

	Возврат ПараметрыЗапуска;
КонецФункции

Функция ОбработатьПараметрыЗапуска(МассивПараметров)

	ПараметрыЗапуска = ПолучитьПараметрыЗапуска(МассивПараметров);
	Если Не ЗначениеЗаполнено(МассивПараметров) Тогда
		Возврат Ложь;
	КонецЕсли;
	КомандаЗапуска = ПараметрыЗапуска.Команда;
	ПутьКТестам = ПараметрыЗапуска.ПутьКТестам;
	НомерТестаДляЗапуска = ПараметрыЗапуска.НомерТестаДляЗапуска;
	НаименованиеТестаДляЗапуска = ПараметрыЗапуска.НаименованиеТестаДляЗапуска;
	ПутьЛогФайлаJUnit = ПараметрыЗапуска.ПутьЛогФайлаJUnit;

	Если КомандаЗапуска = СтруктураПараметровЗапуска.Запустить Тогда
		ТестироватьФайл(Новый Файл(ПутьКТестам), Новый Файл(ПутьЛогФайлаJUnit),
			НаименованиеТестаДляЗапуска, НомерТестаДляЗапуска);
		Возврат Истина;
	КонецЕсли;
	Если КомандаЗапуска = СтруктураПараметровЗапуска.ЗапуститьКаталог Тогда
		ТестироватьКаталог(Новый Файл(ПутьКТестам), Новый Файл(ПутьЛогФайлаJUnit));
		Возврат Истина;
	КонецЕсли;

	ПроверитьСуществованиеФайла(ПутьКТестам);

	Если КомандаЗапуска = СтруктураПараметровЗапуска.ПоказатьСписок Тогда
		Пути.Добавить(ПутьКТестам);
		Лог.Отладка("Файл теста %1", ПутьКТестам);
	КонецЕсли;

	Если КомандаЗапуска = СтруктураПараметровЗапуска.ПоказатьСписок Тогда
		Сообщить("Список тестов:");
	КонецЕсли;

	ЗагрузитьТесты();

	Возврат Истина;
КонецФункции

Процедура ПроверитьСуществованиеФайла(Знач ПутьКТестам)
	Файл = Новый Файл(ПутьКТестам);
	Если Не Файл.Существует() Тогда
		ВызватьИсключение "Не найден файл/каталог " +ПутьКТестам;
	КонецЕсли;
КонецПроцедуры

Функция СоздатьСтруктуруПараметровЗапуска() Экспорт
	СтруктураПараметровЗапуска = Новый Структура;
	СтруктураПараметровЗапуска.Вставить("Запустить", НРег("-run"));
	СтруктураПараметровЗапуска.Вставить("ЗапуститьКаталог", НРег("-runall"));
	СтруктураПараметровЗапуска.Вставить("ПоказатьСписок", НРег("-show"));
	СтруктураПараметровЗапуска.Вставить("Режим_ПутьЛогФайла", НРег("xddReportPath"));
	Возврат СтруктураПараметровЗапуска;
КонецФункции

Функция ЗагрузитьТесты()
	Перем НомерТестаСохр;
	Перем Рез;

	Рез = Истина;

	Для Каждого ПутьТеста Из Пути Цикл
		Файл = Новый Файл(ПутьТеста);
		Если Файл.ЭтоКаталог() Тогда
			ВызватьИсключение "Пока не умею обрабатывать каталоги тестов";
		Иначе
			ПолноеИмяТестовогоСлучая = Файл.ПолноеИмя;
			ИмяКлассаТеста = СтрЗаменить(Файл.ИмяБезРасширения, "-", "")
				+ СтрЗаменить(Строка(Новый УникальныйИдентификатор), "-", "");
			Если КомандаЗапуска = СтруктураПараметровЗапуска.ПоказатьСписок Тогда
				Сообщить("  Файл теста " + ПолноеИмяТестовогоСлучая);
			КонецЕсли;
			Попытка
				ПодключитьСценарий(Файл.ПолноеИмя, ИмяКлассаТеста);
				Тест = Новый(ИмяКлассаТеста);
			Исключение
				ИнфоОшибки = ИнформацияОбОшибке();
				Если ВыводитьОшибкиПодробно Тогда
					ТекстОшибки = ИнфоОшибки.ПодробноеОписаниеОшибки();
				Иначе
					ТекстОшибки = ОписаниеОшибки();
				КонецЕсли;
				Сообщить("Не удалось загрузить тест " + ПолноеИмяТестовогоСлучая + Символы.ПС +
					ТекстОшибки);
				Рез = Ложь;
				РезультатТестирования = ЗначенияСостоянияТестов.Сломался;
				Продолжить;
			КонецПопытки;
			Лог.Отладка("Подключили сценарий теста %1", ПолноеИмяТестовогоСлучая);

			МассивТестовыхСлучаев = ПолучитьТестовыеСлучаи(Тест, ПолноеИмяТестовогоСлучая);
			Если МассивТестовыхСлучаев = Неопределено Тогда
				Продолжить;
			КонецЕсли;

			Для Каждого ТестовыйСлучай Из МассивТестовыхСлучаев Цикл
				Если ЭтоСтрока(ТестовыйСлучай) Тогда
					ИмяТестовогоСлучая = ТестовыйСлучай;
					ПараметрыТеста = Неопределено;
					ПредставлениеТеста = ИмяТестовогоСлучая;
				ИначеЕсли ТипЗнч(ТестовыйСлучай) = Тип("Структура")Тогда
					ИмяТестовогоСлучая = ТестовыйСлучай.ИмяТеста;
					ПараметрыТеста = ТестовыйСлучай.Параметры;
					ПредставлениеТеста = ТестовыйСлучай.Представление;
				Иначе
					ВызватьИсключение "Не умею обрабатывать описание тестового случая из ПолучитьСписокТестов, отличный от строки или структуры";
				КонецЕсли;

				Делегат = Делегаты.Создать(Тест, ИмяТестовогоСлучая, ПараметрыТеста);

				ОписаниеТеста = Новый Структура;
				ОписаниеТеста.Вставить("ТестОбъект", Тест);
				ОписаниеТеста.Вставить("Делегат", Делегат);
				ОписаниеТеста.Вставить("ИмяКласса", ИмяКлассаТеста);
				ОписаниеТеста.Вставить("ПолноеИмя", ПолноеИмяТестовогоСлучая);
				ОписаниеТеста.Вставить("ИмяМетода", ИмяТестовогоСлучая);
				ОписаниеТеста.Вставить("Представление", ПредставлениеТеста);

				НаборТестов.Добавить(ОписаниеТеста);

				НомерТеста = НаборТестов.Количество() - 1;
				Если КомандаЗапуска = СтруктураПараметровЗапуска.ПоказатьСписок Тогда
					Сообщить("    Имя теста <" +ПредставлениеТеста + ">, №теста <" +НомерТеста + ">");

				ИначеЕсли КомандаЗапуска = СтруктураПараметровЗапуска.Запустить
						ИЛИ КомандаЗапуска = СтруктураПараметровЗапуска.ЗапуститьКаталог Тогда
					Если НаименованиеТестаДляЗапуска = Неопределено Тогда
						Если НомерТеста = НомерТестаДляЗапуска Тогда
							НомерТестаСохр = НомерТеста;
						КонецЕсли;
					Иначе
						Если НРег(НаименованиеТестаДляЗапуска) = НРег(ИмяТестовогоСлучая) Тогда
							НомерТестаСохр = НомерТеста;
						КонецЕсли;
					КонецЕсли;
				КонецЕсли;
			КонецЦикла;
		КонецЕсли;
	КонецЦикла;

	Если НомерТестаСохр <> Неопределено Тогда
		ОписаниеТеста = НаборТестов[НомерТестаСохр];
		НаборТестов.Очистить();
		НаборТестов.Добавить(ОписаниеТеста);
	КонецЕсли;

	Возврат Рез;
КонецФункции

Процедура ВыполнитьВсеТесты()
	Если НаборТестов.Количество() > 0 Тогда
		НаборОшибок = Новый Соответствие;
		НаборНереализованныхТестов = Новый Соответствие;
		ДатаНачала = ТекущаяДата();

		СоздаватьОтчетТестированияВФорматеJUnitXML = ЗначениеЗаполнено(ПутьЛогФайлаJUnit);
		Если СоздаватьОтчетТестированияВФорматеJUnitXML Тогда
			ЗаписьXML = Неопределено;
			НачатьЗаписьВФайлОтчетаТестированияВФорматеJUnitXML(ЗаписьXML);
		КонецЕсли;

		Для Сч = 0 По НаборТестов.Количество() - 1 Цикл
			ОписаниеТеста = НаборТестов[Сч];
			ПредыдущийКласс = ?(Сч = 0, Неопределено, НаборТестов[Сч - 1].ИмяКласса);
			СледующийКласс = ?(Сч = НаборТестов.Количество() - 1, Неопределено, НаборТестов[Сч + 1].ИмяКласса);

			Если НЕ ПредыдущийКласс = ОписаниеТеста.ИмяКласса Тогда
				НовыйРезультатТестирования = ВыполнитьПередТестами(ОписаниеТеста);
				РезультатТестирования = ЗапомнитьСамоеХудшееСостояние(РезультатТестирования, НовыйРезультатТестирования);
			КонецЕсли;

			НовыйРезультатТестирования = ВыполнитьПолныйТест(ОписаниеТеста, Сч);
			РезультатТестирования = ЗапомнитьСамоеХудшееСостояние(РезультатТестирования, НовыйРезультатТестирования);

			Если НЕ СледующийКласс = ОписаниеТеста.ИмяКласса Тогда
				НовыйРезультатТестирования = ВыполнитьПослеТестов(ОписаниеТеста);
				РезультатТестирования = ЗапомнитьСамоеХудшееСостояние(РезультатТестирования, НовыйРезультатТестирования);
			КонецЕсли;
		КонецЦикла;

		ВывестиЛогТестирования();

		Если СоздаватьОтчетТестированияВФорматеJUnitXML Тогда
			Если ФорматЛогФайла = ФорматыЛогФайла.GenericExec Тогда
				ЗавершитьЗаписьВФайлОтчетаТестированияВФорматеGExecXML(ЗаписьXML, ДатаНачала);
			Иначе
				ЗавершитьЗаписьВФайлОтчетаТестированияВФорматеJUnitXML(ЗаписьXML, ДатаНачала);
			КонецЕсли;
		КонецЕсли;
	КонецЕсли;
КонецПроцедуры

Процедура СообщитьСтатусТестирования()
	Сообщить(" ");

	Если РезультатТестирования > ЗначенияСостоянияТестов.НеРеализован Тогда
		Сообщить("ОШИБКА: Есть непрошедшие тесты. Красная полоса", СтатусСообщения.Важное);
	ИначеЕсли РезультатТестирования > ЗначенияСостоянияТестов.Прошел Тогда
		Сообщить("ОШИБКА: Есть нереализованные тесты. Желтая полоса", СтатусСообщения.Внимание);
	Иначе
		Сообщить("ОК. Зеленая полоса", СтатусСообщения.Информация);
	КонецЕсли;
КонецПроцедуры

Процедура ВывестиЛогТестирования()
	пройденоТестов = НаборТестов.Количество() - НаборОшибок.Количество() - НаборНереализованныхТестов.Количество();

	Сообщить(" ");
	Сообщить("------------------------------------------------------------");
	Сообщить("                       Общая статистика                     ");
	Сообщить("------------------------------------------------------------");

	Сообщить(" ");
	Сообщить("Тестов пройдено: " + пройденоТестов, СтатусСообщения.Информация);

	Сообщить(" ");
	Сообщить("Тестов не пройдено: " + НаборОшибок.Количество(), СтатусСообщения.Важное);
	Если НаборОшибок.Количество() > 0 Тогда
		Сч = 0;
		Для Каждого КлючЗначение Из НаборОшибок Цикл
			Сч = Сч + 1;
			ОписаниеТеста = КлючЗначение.Ключ;
			Сообщить("    * " + ОписаниеТеста.Представление + " : <" + ОписаниеТеста.ПолноеИмя + ">");
		КонецЦикла;
	КонецЕсли;

	Сообщить(" ");
	Сообщить("Тестов не реализовано \ пропущено: " + НаборНереализованныхТестов.Количество(), СтатусСообщения.Внимание);
	Если НаборНереализованныхТестов.Количество() > 0 Тогда
		Сч = 0;
		Для Каждого КлючЗначение Из НаборНереализованныхТестов Цикл
			Сч = Сч + 1;
			ОписаниеТеста = КлючЗначение.Ключ;
			Сообщить("    * " + ОписаниеТеста.ИмяМетода + " : <" + ОписаниеТеста.ПолноеИмя + ">");
		КонецЦикла;
	КонецЕсли;
КонецПроцедуры

Процедура НачатьЗаписьВФайлОтчетаТестированияВФорматеJUnitXML(ЗаписьXML)
	ЗаписьXML = Новый ЗаписьXML;
	ЗаписьXML.УстановитьСтроку("UTF-8");
	ЗаписьXML.ЗаписатьОбъявлениеXML();

КонецПроцедуры

Процедура ЗавершитьЗаписьВФайлОтчетаТестированияВФорматеJUnitXML(ЗаписьXML, ДатаНачала)

	Утверждения.ПроверитьНеРавенство(НаборТестов.Количество(), 0,
	    "Количество тестов равно 0, что неверно. Метод ЗавершитьЗаписьВФайлОтчетаТестированияВФорматеJUnitXML.");

	ВсегоТестов = НаборТестов.Количество();
	КоличествоОшибок = НаборОшибок.Количество();
	КоличествоНереализованныхТестов = НаборНереализованныхТестов.Количество();

	ВремяВыполнения = ТекущаяДата() - ДатаНачала;

	ЗаписьXML.ЗаписатьНачалоЭлемента("testsuites");
	ЗаписьXML.ЗаписатьАтрибут("tests", XMLСтрока(ВсегоТестов));
	ЗаписьXML.ЗаписатьАтрибут("name", XMLСтрока("xUnitFor1C")); // TODO: указывать путь к набору тестов.
	ЗаписьXML.ЗаписатьАтрибут("time", XMLСтрока(ВремяВыполнения));
	ЗаписьXML.ЗаписатьАтрибут("failures", XMLСтрока(КоличествоОшибок));
	ЗаписьXML.ЗаписатьАтрибут("skipped", XMLСтрока(КоличествоНереализованныхТестов)); // или disabled

	ЗаписьXML.ЗаписатьНачалоЭлемента("testsuite");

	ФайлТестаВрем = Новый Файл(НаборТестов[0].ПолноеИмя);
	Если КомандаЗапуска = СтруктураПараметровЗапуска.Запустить Тогда
		ПутьНабора = ФайлТестаВрем.Имя;
	Иначе
		ПутьНабора = ФайлТестаВрем.Путь;
	КонецЕсли;
	ИмяНабора = ИмяТекущегоТеста(ПутьНабора);
	ФайлТеста = Новый Файл(ПутьНабора);

	ЗаписьXML.ЗаписатьАтрибут("name", ИмяНабора);

	ЗаписьXML.ЗаписатьНачалоЭлемента("properties");
	ЗаписьXML.ЗаписатьКонецЭлемента();

	Для Каждого ОписаниеТеста Из НаборТестов Цикл
		ЗаполнитьРезультатТестовогоСлучая(ЗаписьXML, ОписаниеТеста, НаборОшибок, НаборНереализованныхТестов);
	КонецЦикла;

	ЗаписьXML.ЗаписатьКонецЭлемента();

	СтрокаХМЛ = ЗаписьXML.Закрыть();

	ПутьОтчетаВФорматеJUnitxml = Новый Файл(ПутьФайлаОтчетаТестированияВФорматеJUnitXML() + "/" +ФайлТеста.Имя + ".xml");

	ЗаписатьСтрокуXMLВФайл(СтрокаХМЛ, ПутьОтчетаВФорматеJUnitxml.ПолноеИмя); // таким образом файл будет записан всего один раз, и не будет проблем с обработкой на билд-сервере TeamCity
	Сообщить(" ");
	Сообщить("Путь к лог-файлу проверки в формате Ant.JUnit <" +ПутьОтчетаВФорматеJUnitxml.ПолноеИмя + ">");

КонецПроцедуры

Процедура ЗаполнитьРезультатТестовогоСлучая(ЗаписьXML, ОписаниеТеста, НаборОшибок, НаборНереализованныхТестов)

	ЗаписьXML.ЗаписатьНачалоЭлемента("testcase");
	ЗаписьXML.ЗаписатьАтрибут("classname", ИмяТекущегоТеста(ОписаниеТеста.ПолноеИмя));
	ЗаписьXML.ЗаписатьАтрибут("name", ОписаниеТеста.ИмяМетода);

	СтруктураОшибки		= НаборОшибок.Получить(ОписаниеТеста);

	Если СтруктураОшибки = Неопределено Тогда
		СтруктураОшибки		= НаборНереализованныхТестов.Получить(ОписаниеТеста);
	КонецЕсли;

	Если СтруктураОшибки <> Неопределено Тогда
		СтрокаРезультат = ?(СтруктураОшибки.СостояниеВыполнения = ЗначенияСостоянияТестов.Сломался,
							"failure", "skipped");

		ЗаписьXML.ЗаписатьАтрибут("status", СтрокаРезультат);
		ЗаписьXML.ЗаписатьНачалоЭлемента(СтрокаРезультат);

		СтрокаОписание = СтруктураОшибки.Описание;
		// TODO: НайтиНедопустимыеСимволыXML()
		XMLОписание = XMLСтрока(СтрокаОписание);
		ЗаписьXML.ЗаписатьАтрибут("message", XMLОписание);

		ЗаписьXML.ЗаписатьКонецЭлемента();
	Иначе
		ЗаписьXML.ЗаписатьАтрибут("status", "passed");
	КонецЕсли;

	ЗаписьXML.ЗаписатьКонецЭлемента();

КонецПроцедуры

Процедура ЗавершитьЗаписьВФайлОтчетаТестированияВФорматеGExecXML(ЗаписьXML, ДатаНачала)

	Утверждения.ПроверитьНеРавенство(НаборТестов.Количество(), 0,
	    "Количество тестов равно 0, что неверно. Метод ЗавершитьЗаписьВФайлОтчетаТестированияВФорматеGExecXML.");

	ВсегоТестов = НаборТестов.Количество();
	КоличествоОшибок = НаборОшибок.Количество();
	КоличествоНереализованныхТестов = НаборНереализованныхТестов.Количество();

	ВремяВыполнения = ТекущаяДата() - ДатаНачала;

	ЗаписьXML.ЗаписатьНачалоЭлемента("testExecutions");
	ЗаписьXML.ЗаписатьАтрибут("version", XMLСтрока("1"));

	КаталогПроекта = ТекущийКаталог();

	ФайлТестаВрем = Новый Файл(НаборТестов[0].ПолноеИмя);
	Если КомандаЗапуска = СтруктураПараметровЗапуска.Запустить Тогда
		ПутьНабора = ФайлТестаВрем.Имя;
	Иначе
		ПутьНабора = ФайлТестаВрем.Путь;
	КонецЕсли;
	ИмяНабора = ИмяТекущегоТеста(ПутьНабора);
	ФайлТеста = Новый Файл(ПутьНабора);

	ИмяТекущегоТеста = "";

	Для Каждого ОписаниеТеста Из НаборТестов Цикл
		ПредыдущееИмяТеста = ФС.ОтносительныйПуть(КаталогПроекта, ОписаниеТеста.ПолноеИмя, "/");
		Если НЕ ИмяТекущегоТеста = ПредыдущееИмяТеста Тогда
			Если НЕ ИмяТекущегоТеста = "" Тогда
				ЗаписьXML.ЗаписатьКонецЭлемента();
			КонецЕсли;
			ИмяТекущегоТеста = ФС.ОтносительныйПуть(КаталогПроекта, ОписаниеТеста.ПолноеИмя, "/");
			ЗаписьXML.ЗаписатьНачалоЭлемента("file");
			ЗаписьXML.ЗаписатьАтрибут("path", ИмяТекущегоТеста);
		КонецЕсли;
		ЗаполнитьРезультатТестовогоСлучаяGExec(ЗаписьXML, ОписаниеТеста, НаборОшибок, НаборНереализованныхТестов);
	КонецЦикла;

	Если НЕ ИмяТекущегоТеста = "" Тогда
		ЗаписьXML.ЗаписатьКонецЭлемента();
	КонецЕсли;

	ЗаписьXML.ЗаписатьКонецЭлемента();

	СтрокаХМЛ = ЗаписьXML.Закрыть();

	ПутьОтчетаВФорматеJUnitxml = Новый Файл(ПутьФайлаОтчетаТестированияВФорматеJUnitXML()
		+ "/" + ФайлТеста.Имя + ".xml");

	ЗаписатьСтрокуXMLВФайл(СтрокаХМЛ, ПутьОтчетаВФорматеJUnitxml.ПолноеИмя);
	Сообщить(" ");
	Сообщить("Путь к лог-файлу проверки в формате Generic execution <" + ПутьОтчетаВФорматеJUnitxml.ПолноеИмя + ">");

КонецПроцедуры // ЗавершитьЗаписьВФайлОтчетаТестированияВФорматеGExecXML()

Процедура ЗаполнитьРезультатТестовогоСлучаяGExec(ЗаписьXML, ОписаниеТеста, НаборОшибок, НаборНереализованныхТестов)

	ЗаписьXML.ЗаписатьНачалоЭлемента("testCase");
	ЗаписьXML.ЗаписатьАтрибут("name", ОписаниеТеста.ИмяМетода);
	Если ОписаниеТеста.Свойство("ВремяВыполнения") Тогда
		ЗаписьXML.ЗаписатьАтрибут("duration", Окр(ОписаниеТеста.ВремяВыполнения, 0));
	Иначе
		ЗаписьXML.ЗаписатьАтрибут("duration", 1);
	КонецЕсли;

	СтруктураОшибки		= НаборОшибок.Получить(ОписаниеТеста);

	Если СтруктураОшибки = Неопределено Тогда
		СтруктураОшибки		= НаборНереализованныхТестов.Получить(ОписаниеТеста);
	КонецЕсли;

	Если СтруктураОшибки <> Неопределено Тогда
		Если СтруктураОшибки.СостояниеВыполнения = ЗначенияСостоянияТестов.Сломался Тогда
			ЗаписьXML.ЗаписатьНачалоЭлемента("failure");
		Иначе
			ЗаписьXML.ЗаписатьНачалоЭлемента("skipped");
		КонецЕсли;
		ЗаписьXML.ЗаписатьАтрибут("message", "(" + СтруктураОшибки.ИнфоОшибки.НомерСтроки + "): "
			+ СокрЛП(СтруктураОшибки.ИнфоОшибки.ИсходнаяСтрока));

		СтрокаОписание = СтруктураОшибки.Описание;
		// TODO: НайтиНедопустимыеСимволыXML()
		XMLОписание = XMLСтрока(СтрокаОписание);
		ЗаписьXML.ЗаписатьТекст(XMLОписание);

		ЗаписьXML.ЗаписатьКонецЭлемента();
	КонецЕсли;

	ЗаписьXML.ЗаписатьКонецЭлемента();

КонецПроцедуры // ЗаполнитьРезультатТестовогоСлучаяGExec()

Процедура ЗаписатьСтрокуXMLВФайл(СтрокаХМЛ, ПутьКФайлу)

	ЗаписьXML = Новый ЗаписьXML;
	ЗаписьXML.ОткрытьФайл(ПутьКФайлу);
	ЗаписьXML.ЗаписатьБезОбработки(СтрокаХМЛ);
	ЗаписьXML.Закрыть();

КонецПроцедуры // ЗаписатьСтрокуXMLВФайл()

Функция ПутьФайлаОтчетаТестированияВФорматеJUnitXML()
	Возврат ?(ЗначениеЗаполнено(ПутьЛогФайлаJUnit), ПутьЛогФайлаJUnit, ТекущийКаталог());
КонецФункции

Функция ИмяТекущегоТеста(ПолныйПуть)
	Файл = Новый Файл(ПолныйПуть);
	Возврат Файл.ИмяБезРасширения;
КонецФункции

Функция ВыполнитьТест(ОписаниеТеста, Сч)
	Перем Рез;

	Тест = ОписаниеТеста.ТестОбъект;
	ИмяМетода = ОписаниеТеста.ИмяМетода;

	Успешно = Истина;
	Если Не Успешно Тогда // TODO странная проверка - только что установили в Истина, и проверяем на Ложь (
		Рез = ЗначенияСостоянияТестов.Сломался;
	Иначе
		Если Не Рефлектор.МетодСуществует(Тест, ИмяМетода) Тогда
			ПоказатьИнформациюПоТесту(Сч, ИмяМетода);
			Рез = ВывестиОшибкуВыполненияТеста(ЗначенияСостоянияТестов.НеРеализован, "Не найден тестовый метод "
				+ ИмяМетода, ОписаниеТеста, "", Неопределено);
			Сообщить("  ");
		Иначе
			Попытка
				НачалоВыполнения = ТекущаяУниверсальнаяДатаВМиллисекундах();
				ОписаниеТеста.Делегат.Исполнить();
				ВремяВыполнения = ТекущаяУниверсальнаяДатаВМиллисекундах() - НачалоВыполнения;

				Рез = ЗначенияСостоянияТестов.Прошел;
			Исключение
				ИнфоОшибки = ИнформацияОбОшибке();

				//уберем стек-трейс, который приезжает из библиотеки asserts
				ОписаниеОшибки = ИнфоОшибки.Описание;
				ПозицияСтрокиСтрекТрейс = Найти(ОписаниеОшибки, "Стек трейс:");
				Если ПозицияСтрокиСтрекТрейс > 0 Тогда
					ОписаниеОшибки = Лев(ОписаниеОшибки, ПозицияСтрокиСтрекТрейс);
				КонецЕсли;

				ВремяВыполнения = ТекущаяУниверсальнаяДатаВМиллисекундах() - НачалоВыполнения;
				ПоказатьИнформациюПоТесту(Сч, ИмяМетода);

				ТекстОшибки = ОписаниеОшибки + "
				|" + ПолучитьОписаниеСтекаВызовов(ИнфоОшибки);

				Если ВыводитьОшибкиПодробно Тогда
					ТекстОшибки = ТекстОшибки + "
					|" + ИнфоОшибки.ПодробноеОписаниеОшибки();
				КонецЕсли;
				Рез = ВывестиОшибкуВыполненияТеста(ЗначенияСостоянияТестов.Сломался, "", ОписаниеТеста,
					ТекстОшибки, ИнфоОшибки);
				Сообщить("  ");
			КонецПопытки;
			Если ОписаниеТеста.Свойство("ВремяВыполнения") Тогда
				ОписаниеТеста.ВремяВыполнения = ОписаниеТеста.ВремяВыполнения + ВремяВыполнения;
			Иначе
				ОписаниеТеста.Вставить("ВремяВыполнения", ВремяВыполнения);
			КонецЕсли;
		КонецЕсли;

	КонецЕсли;

	Возврат Рез;
КонецФункции

Функция ВыполнитьПередТестами(ОписаниеТеста)

	Возврат ВыполнитьПоАннотации(ОписаниеТеста, "инициализация", "ПередЗапускомТестов");

КонецФункции

Функция ВыполнитьПослеТестов(ОписаниеТеста)

	Возврат ВыполнитьПоАннотации(ОписаниеТеста, "завершение", "ПослеЗапускаТестов");

КонецФункции

Функция ВыполнитьПередТестом(ОписаниеТеста)

	Возврат ВыполнитьПоАннотации(ОписаниеТеста, "перед", "ПередЗапускомТеста");

КонецФункции

Функция ВыполнитьПослеТеста(ОписаниеТеста)

	Возврат ВыполнитьПоАннотации(ОписаниеТеста, "после", "ПослеЗапускаТеста");

КонецФункции

Функция ВыполнитьПоАннотации(ОписаниеТеста, СтрокаАннотации, ДополнительныйШаг)

	ТестыПеред = Новый Массив;
	ТестыПеред.Добавить(ДополнительныйШаг);

	ТестыПеред = НайтиАннотированныеМетоды(ОписаниеТеста.ТестОбъект, СтрокаАннотации);

	Если ТестыПеред = Неопределено Тогда
		ТестыПеред = Новый Массив;
		ТестыПеред.Добавить(ДополнительныйШаг);
	КонецЕсли;

	Рез = ЗначенияСостоянияТестов.Прошел;
	Для Каждого ШагПередЗапуском Из ТестыПеред Цикл

		Успешно = ВыполнитьПроцедуруТестовогоСлучая(
			ШагПередЗапуском,
			ОписаниеТеста.ТестОбъект,
			ОписаниеТеста
		);

		Если Не Успешно Тогда
			Рез = ЗначенияСостоянияТестов.Сломался;
		КонецЕсли;

	КонецЦикла;

	Возврат Рез;

КонецФункции

Функция ВыполнитьПолныйТест(ОписаниеТеста, НомерТеста)

	НовыйРезультатТестирования = ВыполнитьПередТестом(ОписаниеТеста);
	РезультатТестирования = ЗапомнитьСамоеХудшееСостояние(РезультатТестирования, НовыйРезультатТестирования);

	НовыйРезультатТестирования = ВыполнитьТест(ОписаниеТеста, НомерТеста);
	РезультатТестирования = ЗапомнитьСамоеХудшееСостояние(РезультатТестирования, НовыйРезультатТестирования);

	НовыйРезультатТестирования = ВыполнитьПослеТеста(ОписаниеТеста);
	РезультатТестирования = ЗапомнитьСамоеХудшееСостояние(РезультатТестирования, НовыйРезультатТестирования);

	Возврат РезультатТестирования;
КонецФункции

Функция ПолучитьОписаниеСтекаВызовов(Знач ИнфоОшибки)

	Стек = ИнфоОшибки.ПолучитьСтекВызовов();
	ТекстСтека = "";
	Отступ = "                          ";
	ДлинаОтступа = СтрДлина(Отступ);
	Сч = 0;
	Для Каждого Кадр Из Стек Цикл
		Если Сч > ДлинаОтступа Тогда
			Сч = 1;
		КонецЕсли;

		ТекстСтека = ТекстСтека + Символы.ПС
		+ Лев(Отступ, Сч) + СтрШаблон("-> %1 (%2), %3", Кадр.Метод, Кадр.НомерСтроки, Кадр.ИмяМодуля);
		Сч = Сч + 2;
	КонецЦикла;

	Возврат ТекстСтека;

КонецФункции

Функция ВывестиОшибкуВыполненияТеста(СостояниеВыполнения, ПредставлениеОшибки, ОписаниеТеста, ТекстОшибки, ИнфоОшибки)
	ИмяМетода = ?(ЗначениеЗаполнено(ОписаниеТеста.Представление), ОписаниеТеста.Представление, ОписаниеТеста.ИмяМетода);

	сообщение = ?(ПредставлениеОшибки = "", "", ПредставлениеОшибки + Символы.ПС) +
		"Тест: <" + ИмяМетода + ">"  + Символы.ПС +
		"Файл: <" + ОписаниеТеста.ПолноеИмя + "> " + Символы.ПС +
		"Сообщение: " + ТекстОшибки;

	Если СостояниеВыполнения = ЗначенияСостоянияТестов.НеРеализован Тогда
		ВывестиПредупреждение(сообщение);
	Иначе
		ВывестиОшибку(сообщение);
	КонецЕсли;

	СтруктураОшибки = Новый Структура();

	СтруктураОшибки.Вставить("ИмяТестовогоНабора", ИмяМетода);

	стИнфоОшибки = Новый Структура("СостояниеВыполнения,ИмяМодуля,ИсходнаяСтрока,НомерСтроки,Описание");
	Если ИнфоОшибки <> Неопределено Тогда
		ЗаполнитьЗначенияСвойств(стИнфоОшибки, ИнфоОшибки);
	КонецЕсли;
	стИнфоОшибки.Вставить("Причина",  Неопределено);

	стИнфоОшибкиЦикл = стИнфоОшибки;
	Если ИнфоОшибки <> Неопределено Тогда
		ИнфоОшибки = ИнфоОшибки.Причина;
	КонецЕсли;
	Пока ИнфоОшибки <> Неопределено Цикл
		стИнфоОшибкиЦикл.Причина = Новый Структура("ИмяМодуля,ИсходнаяСтрока,НомерСтроки,Описание");
		стИнфоОшибкиЦикл = стИнфоОшибкиЦикл.Причина;
		ЗаполнитьЗначенияСвойств(стИнфоОшибкиЦикл, ИнфоОшибки);
		стИнфоОшибкиЦикл.Вставить("Причина",  Неопределено);

		ИнфоОшибки = ИнфоОшибки.Причина;
	КонецЦикла;

	ИмяТестовогоСлучаяДляОписанияОшибки = ИмяМетода;

	СтруктураОшибки.Вставить("ИмяТестовогоСлучая", ИмяТестовогоСлучаяДляОписанияОшибки);
	СтруктураОшибки.Вставить("СостояниеВыполнения",  СостояниеВыполнения);

	СтруктураОшибки.Вставить("Описание",              ТекстОшибки);
	СтруктураОшибки.Вставить("ИнфоОшибки",            стИнфоОшибки);
	СтруктураОшибки.Вставить("ПолныйПуть",            ОписаниеТеста.ПолноеИмя);

	Если СостояниеВыполнения = ЗначенияСостоянияТестов.Сломался Тогда
		НаборОшибок.Вставить(ОписаниеТеста, СтруктураОшибки);
	Иначе
		НаборНереализованныхТестов.Вставить(ОписаниеТеста, СтруктураОшибки);
	КонецЕсли;

	Возврат СостояниеВыполнения;

КонецФункции

Функция ВыполнитьПроцедуруТестовогоСлучая(ИмяМетода, ТестОбъект, ОписаниеТеста)
	Успешно = Ложь;

	Если Не Рефлектор.МетодСуществует(ТестОбъект, ИмяМетода) Тогда
		Возврат Истина;
	КонецЕсли;

	Попытка
		НачалоВыполнения = ТекущаяУниверсальнаяДатаВМиллисекундах();
		Рефлектор.ВызватьМетод(ТестОбъект, ИмяМетода);
		ВремяВыполнения = ТекущаяУниверсальнаяДатаВМиллисекундах() - НачалоВыполнения;
		Успешно = Истина;
	Исключение
		ВремяВыполнения = ТекущаяУниверсальнаяДатаВМиллисекундах() - НачалоВыполнения;
		ИнфоОшибки = ИнформацияОбОшибке();
		ТекстОшибки = ОписаниеОшибки();

		ВывестиОшибкуВыполненияТеста(
			ЗначенияСостоянияТестов.Сломался,
			"Упал метод " + ИмяМетода,
			ОписаниеТеста,
			ТекстОшибки,
			ИнфоОшибки)
		;

	КонецПопытки;

	Если ОписаниеТеста.Свойство("ВремяВыполнения") Тогда
		ОписаниеТеста.ВремяВыполнения = ОписаниеТеста.ВремяВыполнения + ВремяВыполнения;
	Иначе
		ОписаниеТеста.Вставить("ВремяВыполнения", ВремяВыполнения);
	КонецЕсли;

	Возврат Успешно;
КонецФункции

Функция ПолучитьПредставлениеТестовогоСлучая(ИмяТеста, СтруктураПараметров)
	Если ТипЗнч(СтруктураПараметров) <> Тип("Структура") Тогда
		Возврат ИмяТеста;
	КонецЕсли;
	СтрПараметры = "";
	Разделитель = "";
	Для каждого ЭлементСтруктуры Из СтруктураПараметров Цикл
		СтрПараметры = СтрПараметры + Разделитель +
                       СтрШаблон("%1:""%2""", ЭлементСтруктуры.Ключ, Строка(ЭлементСтруктуры.Значение));
		Разделитель = ", ";
	КонецЦикла;
	Если СтрДлина(СтрПараметры) > 100 Тогда
		СтрПараметры = Лев(СтрПараметры, 97) + "...";
	КонецЕсли;
	Возврат СтрШаблон("%1{%2}", ИмяТеста, СтрПараметры);
КонецФункции

Процедура ДобавитьТест(ИмяТестовогоСлучая, СтруктураПараметров = Неопределено, Представление = "") Экспорт
	ВремМассивТестовыхСлучаев.Добавить(Новый Структура("ИмяТеста,Параметры,Представление",
		ИмяТестовогоСлучая,
		СтруктураПараметров,
		?(ПустаяСтрока(Представление), ПолучитьПредставлениеТестовогоСлучая(ИмяТестовогоСлучая, СтруктураПараметров), Представление)
	));
КонецПроцедуры

Функция ПолучитьТестовыеСлучаи(ТестОбъект, ПолноеИмяОбъекта)

	Попытка

		МассивТестовыхСлучаев = ПрочитатьТестовыеСлучаиОбъекта(ТестОбъект, ЭтотОбъект);

	Исключение
		ВывестиОшибку("Набор тестов не загружен: " + ПолноеИмяОбъекта + "
		|	Ошибка получения списка тестовых случаев: " + ОписаниеОшибки());
		Возврат Неопределено;
	КонецПопытки;

	Лог.Отладка("Получили массив тестовых случаев теста %1", ПолноеИмяОбъекта);

	Если ТипЗнч(МассивТестовыхСлучаев) <> Тип("Массив") Тогда

		ВывестиОшибку("Набор тестов не загружен: " + ПолноеИмяОбъекта + "
				|	Ошибка получения списка тестовых случаев: вместо массива имен тестовых случаев получен объект <" + Строка(ТипЗнч(МассивТестовыхСлучаев)) + ">");
		ТестОбъект = Неопределено;
		Возврат Неопределено;

	КонецЕсли;

	Если НЕ ПроверитьМассивТестовыхСлучаев(МассивТестовыхСлучаев, ПолноеИмяОбъекта) Тогда
		Возврат Неопределено;
	КонецЕсли;

	Возврат МассивТестовыхСлучаев;

КонецФункции

Функция ПроверитьМассивТестовыхСлучаев(МассивТестовыхСлучаев, ПолноеИмяОбъекта)
	Для каждого данныеТеста Из МассивТестовыхСлучаев Цикл
		Если ТипЗнч(данныеТеста) = Тип("Строка") Тогда
			Лог.Отладка("Имя теста: %1", данныеТеста);
			Продолжить;
		КонецЕсли;

		Если ТипЗнч(данныеТеста) <> Тип("Структура") Тогда
			ВывестиОшибку("Набор тестов не загружен: " + ПолноеИмяОбъекта + "
			|	Ошибка получения структуры описания тестового случая: " + ОписаниеОшибки());
			Возврат Ложь;
		КонецЕсли;
		Если НЕ данныеТеста.Свойство("ИмяТеста") Тогда
			ВывестиОшибку("Набор тестов не загружен: " + ПолноеИмяОбъекта + "
			|	Не задано имя теста в структуре описания тестового случая: " + ОписаниеОшибки());
			Возврат Ложь;
		КонецЕсли;
		Лог.Отладка("Имя теста: %1", данныеТеста.ИмяТеста);
	КонецЦикла;
	Возврат Истина;
КонецФункции

Процедура ПоказатьИнформациюПоТесту(Знач Номер, Знач Тест)
	Сообщить("---------------------------------------------------------");
	Сообщить(" ");
	Сообщить("Тест №" + Строка(Номер) + ": " + Тест);
	Сообщить(" ");
КонецПроцедуры

// Устанавливает новое текущее состояние выполнения тестов
// в соответствии с приоритетами состояний:
// 		Красное - заменяет все другие состояния
// 		Желтое - заменяет только зеленое состояние
// 		Зеленое - заменяет только серое состояние (тест не выполнялся ни разу).
Функция ЗапомнитьСамоеХудшееСостояние(ТекущееСостояние, НовоеСостояние)

	ТекущееСостояние = Макс(ТекущееСостояние, НовоеСостояние);
	Возврат ТекущееСостояние;

КонецФункции

Функция ЭтоСтрока(Значение)
	Возврат Строка(Значение) = Значение;
КонецФункции

Функция ФорматДСО(ДопСообщениеОшибки)
	Если ДопСообщениеОшибки = "" Тогда
		Возврат "";
	КонецЕсли;

	Возврат Символы.ПС + ДопСообщениеОшибки;
КонецФункции

Функция ВСтрокеСодержатсяТолькоЦифры(Знач ИсходнаяСтрока)

	рез = Ложь;
	ДлинаСтроки = СтрДлина(ИсходнаяСтрока);
	Для Сч = 1 По ДлинаСтроки Цикл
		ТекущийСимвол = КодСимвола(Сред(ИсходнаяСтрока, Сч, 1));
		Если 48 <= ТекущийСимвол И ТекущийСимвол <= 57 Тогда
			рез = Истина;
		Иначе
			рез = Ложь;
			Прервать;
		КонецЕсли;
	КонецЦикла;
	Возврат рез;
КонецФункции

Процедура УстановитьПутьЛогФайлаJUnit(Знач ЛогФайлJUnit)
	Если ЛогФайлJUnit = Неопределено Тогда
		ПутьЛогФайлаJUnit = Неопределено;
	Иначе
		ПутьЛогФайлаJUnit = ЛогФайлJUnit.ПолноеИмя;
	КонецЕсли;
КонецПроцедуры

// Устанавливает формат лог файла результатов тестирования
//
//  Параметры:
// 		НовыйФорматЛогФайла		- Число		- формат лог файла из метода ФорматыЛогФайла
//
Процедура УстановитьФорматЛогФайла(Знач НовыйФорматЛогФайла = Неопределено) Экспорт

	Если НовыйФорматЛогФайла = Неопределено Тогда
		ФорматЛогФайла = ФорматыЛогФайла.JUnit;
	Иначе
		ФорматЛогФайла = НовыйФорматЛогФайла;
	КонецЕсли;

КонецПроцедуры // УстановитьФорматЛогФайла()

// Возвращает фикс.структуру состояния тестов
//
// Состояния тестов - ВАЖЕН порядок заполнения в мЗначенияСостоянияТестов, используется в ЗапомнитьСамоеХудшееСостояние
//
//  Возвращаемое значение:
// 		Ключ/Значение - "НеВыполнялся"		, -1; // код 0 используется в командной строке для показа нормального завершения
// 		Ключ/Значение - "Прошел"		, 0; // код 0 используется в командной строке для показа нормального завершения
// 		Ключ/Значение - "НеРеализован", 2;
// 		Ключ/Значение - "Сломался"	, 3;
//
Функция ЗначенияСостоянияТестов() Экспорт
	Если ЗначенияСостоянияТестов = Неопределено Тогда
		ЗначенияСостоянияТестов = Новый Структура;
		ЗначенияСостоянияТестов.Вставить("НеВыполнялся", -1);
		// код 0 используется в командной строке для показа нормального завершения
		ЗначенияСостоянияТестов.Вставить("Прошел"		, 0);
		ЗначенияСостоянияТестов.Вставить("НеРеализован", 2);
		ЗначенияСостоянияТестов.Вставить("Сломался"	, 3);

		ЗначенияСостоянияТестов = Новый ФиксированнаяСтруктура(ЗначенияСостоянияТестов);
	КонецЕсли;
	Возврат ЗначенияСостоянияТестов;
	// } Состояния тестов
КонецФункции

// Возвращает фикс.структуру форматов лог файлов
//
//  Возвращаемое значение:
// 		Ключ/Значение - "JUnit"		 , 1     - формат JUnit
// 		Ключ/Значение - "GenericExec", 2;    - формат Generic execution (Sonar)
//
Функция ФорматыЛогФайла() Экспорт

	Если ФорматыЛогФайла = Неопределено Тогда
		ФорматыЛогФайла = Новый Структура;
		ФорматыЛогФайла.Вставить("JUnit"      , 1);
		ФорматыЛогФайла.Вставить("GenericExec", 2);

		ФорматыЛогФайла = Новый ФиксированнаяСтруктура(ФорматыЛогФайла);
	КонецЕсли;

	Возврат ФорматыЛогФайла;

КонецФункции // ФорматыЛогФайла()

// Выводит сообщение. В тестах ВСЕГДА должна использоваться ВМЕСТО метода Сообщить().
//

Функция ВывестиПредупреждение(Ошибка) Экспорт

	НужныйТекстОшибки = Ошибка;

	ВывестиСообщение("ПРЕДУПРЕЖДЕНИЕ: " + НужныйТекстОшибки, СтатусСообщения.Внимание);

	Возврат НужныйТекстОшибки;
КонецФункции

Процедура ВывестиСообщение(ТекстСообщения, Статус = Неопределено) Экспорт
	Если Статус = Неопределено Тогда
		Статус = СтатусСообщения.Обычное;
	КонецЕсли;

	Сообщить(ТекстСообщения, Статус);
КонецПроцедуры

// Вызывает исключение с заданным текстом ошибки для прерывания выполнения тестового случая.
//
Процедура ПрерватьТест(ТекстОшибки) Экспорт

	ВызватьИсключение ТекстОшибки;

КонецПроцедуры

Функция ВывестиОшибку(Ошибка) Экспорт

	НужныйТекстОшибки = Ошибка;

	ВывестиСообщение("ОШИБКА: " + НужныйТекстОшибки, СтатусСообщения.Важное);

	Возврат НужныйТекстОшибки;
КонецФункции

// Получает список тестовых случаев из сценария
//
// Параметры:
//  ТестОбъект  - Объект - Объект тестового сценария
//
//  МенеджерТестирования  - Объект - Объект менеджера тестирования
//
// Возвращаемое значение:
//   Массив   - массив строк-имен методов тестового сценария
//
Функция ПрочитатьТестовыеСлучаиОбъекта(Знач ТестОбъект, Знач МенеджерТестирования)
	МассивТестовыхСлучаев = ПрочитатьТестовыеСлучаиОбъектаВызовомМетода(ТестОбъект, МенеджерТестирования);
	Если Неопределено <> МассивТестовыхСлучаев Тогда
		Возврат МассивТестовыхСлучаев;
	КонецЕсли;

	МассивТестовыхСлучаев = НайтиАннотированныеТесты(ТестОбъект);

	Возврат МассивТестовыхСлучаев;
КонецФункции

// Получает список тестовых случаев вызовом метода с предопределенным именем
//
// Параметры:
//  ТестОбъект  - Объект - Объект тестового сценария
//
//  МенеджерТестирования  - Объект - Объект менеджера тестирования
//
// Возвращаемое значение:
//   Массив   - массив строк-имен методов тестового сценария
//
Функция ПрочитатьТестовыеСлучаиОбъектаВызовомМетода(Знач ТестОбъект, Знач МенеджерТестирования)

	Если НЕ Рефлектор.МетодСуществует(ТестОбъект, "ПолучитьСписокТестов") Тогда
		Возврат Неопределено;
	КонецЕсли;

	// С помощью ПолучитьСписокТестов() можно определять список тестов двумя способами:
	//     * вернуть массив тестов из ПолучитьСписокТестов()
	//     * внутри ПолучитьСписокТестов() использовать ДобавитьТест() менеджера тестирования, который передается методу как параметр
	// Мы хотим получить единый список тестов, которые были установлены обоими способами
	// Объединим в один список тесты, установленные с помощью ДобавитьТест(), с возвращенными из ПолучитьСписокТестов()
	ВремМассивТестовыхСлучаев = Новый Массив;
	МассивТестовыхСлучаев = ТестОбъект.ПолучитьСписокТестов(МенеджерТестирования);
	Если ТипЗнч(МассивТестовыхСлучаев) = Тип("Массив") Тогда
		Для каждого ТестовыйСлучай Из МассивТестовыхСлучаев Цикл
			ВремМассивТестовыхСлучаев.Добавить(ТестовыйСлучай);
		КонецЦикла;
	КонецЕсли;
	МассивТестовыхСлучаев = ВремМассивТестовыхСлучаев;
	ВремМассивТестовыхСлучаев = Неопределено;

	Возврат МассивТестовыхСлучаев;
КонецФункции

// Получает список тестовых случаев получая методы с аннотацией &тест
//
// Параметры:
//  ТестОбъект  - Объект - Объект тестового сценария
//
//  МенеджерТестирования  - Объект - Объект менеджера тестирования
//
// Возвращаемое значение:
//   Массив   - массив строк-имен методов тестового сценария
//
Функция НайтиАннотированныеМетоды(Знач ТестОбъект, Аннотация)

	ТаблицаМетодов = Рефлектор.ПолучитьТаблицуМетодов(ТестОбъект);
	Если ТаблицаМетодов.Колонки.Найти("Аннотации") = Неопределено Тогда
		Возврат Неопределено;
	КонецЕсли;

	МассивТестовыхСлучаев = Неопределено;
	ВремМассивТестовыхСлучаев = Новый Массив;
	Для Каждого ТестовыйСлучай Из ТаблицаМетодов Цикл
		ДополнитьМассивПоАннотациям(ВремМассивТестовыхСлучаев, ТестовыйСлучай, Аннотация);
	КонецЦикла;

	Если ВремМассивТестовыхСлучаев.Количество() > 0 Тогда
		МассивТестовыхСлучаев = ВремМассивТестовыхСлучаев;
	КонецЕсли;
	ВремМассивТестовыхСлучаев = Неопределено;

	Возврат МассивТестовыхСлучаев;
КонецФункции

Функция НайтиАннотированныеТесты(Знач ТестОбъект)

	ТаблицаМетодов = Рефлектор.ПолучитьТаблицуМетодов(ТестОбъект);
	Если ТаблицаМетодов.Колонки.Найти("Аннотации") = Неопределено Тогда
		Возврат Неопределено;
	КонецЕсли;

	ИмяАннотацииТест = "тест";
	МассивТестовыхСлучаев = Новый Массив;
	Для Каждого МетодКласса Из ТаблицаМетодов Цикл
		
		Если МетодКласса.Аннотации = Неопределено Тогда
			Продолжить;
		КонецЕсли;

		ЭтоТест = ЕстьАннотация(МетодКласса.Аннотации, ИмяАннотацииТест);

		Если ЭтоТест Тогда
			ТестовыеСлучаи = ОписаниеТестаПоАннотации(
				МетодКласса.Имя,
				МетодКласса.КоличествоПараметров,
				МетодКласса.Аннотации);

			Если ТипЗнч(ТестовыеСлучаи) = Тип("Строка") Тогда
				МассивТестовыхСлучаев.Добавить(ТестовыеСлучаи);
			Иначе
				Для Каждого Случай Из ТестовыеСлучаи Цикл
					МассивТестовыхСлучаев.Добавить(Случай);
				КонецЦикла;
			КонецЕсли;
		КонецЕсли;

	КонецЦикла;

	Возврат МассивТестовыхСлучаев;

КонецФункции

Функция НайтиАннотации(Знач Таблица, Знач ИмяАннотации)
	Результат = Новый Массив;
	Для Каждого СтрАннотация Из Таблица Цикл
		Если ВРег(СтрАннотация.Имя) = ВРег(ИмяАннотации) Тогда
			Результат.Добавить(СтрАннотация);
		КонецЕсли;
	КонецЦикла;
	Возврат Результат;
КонецФункции

Функция ЕстьАннотация(Знач Таблица, Знач ИмяАннотации)
	Возврат НайтиАннотации(Таблица, ИмяАннотации).Количество() <> 0;
КонецФункции

Функция ОписаниеТестаПоАннотации(Знач ИмяМетода, Знач КоличествоПараметров, Знач Аннотации)

	ИмяАннотацииПараметры = "параметры";
	СтрокиАннотаций = НайтиАннотации(Аннотации, ИмяАннотацииПараметры);
	Если СтрокиАннотаций.Количество() = 0 Тогда
		Возврат ИмяМетода; // не параметризованный тест
	КонецЕсли;

	ТестовыеСлучаи = Новый Массив;
	Для Каждого ВариантТеста Из СтрокиАннотаций Цикл

		ПараметрыАннотации = ВариантТеста.Параметры;
		Если Не ПараметрыАннотации.Количество() Тогда
			ВызватьИсключение СтрШаблон("Неверное применение аннотации %1 на методе %2. Не заданы параметры",
				ИмяАннотацииПараметры,
				ИмяМетода);
		КонецЕсли;
	
		Если ПараметрыАннотации.Количество() <> КоличествоПараметров Тогда
			ВызватьИсключение СтрШаблон("Неверное применение аннотации %1 на методе %2. Не совпадает число параметров в методе и в аннотации",
				ИмяАннотацииПараметры,
				ИмяМетода);
		КонецЕсли;

		ЗначенияПараметров = Новый Массив;
		Для Каждого Параметр Из ПараметрыАннотации Цикл
			Если Параметр.Имя <> Неопределено Тогда
				// Тут можно сделать что-то типа method-source, но не сегодня
				ВызватьИсключение СтрШаблон("Неверное применение аннотации %1 на методе %2. Ожидаются параметры-значения, без имен",
					ИмяАннотацииПараметры,
					ИмяМетода);
			КонецЕсли;

			ЗначенияПараметров.Добавить(Параметр.Значение);
		КонецЦикла;

		Случай = Новый Структура("ИмяТеста,Параметры,Представление", 
			ИмяМетода,
			ЗначенияПараметров,
			СтрШаблон("%1(%2)", ИмяМетода, СтрСоединить(ЗначенияПараметров, ","))
		);
		ТестовыеСлучаи.Добавить(Случай);
	КонецЦикла;

	Возврат ТестовыеСлучаи;

КонецФункции

Процедура ДополнитьМассивПоАннотациям(ВхМассив, ТестовыйСлучай, ИмяАннотация)

	Если ТестовыйСлучай.Аннотации = Неопределено Тогда
		Возврат;
	КонецЕсли;

	Для Каждого Аннотация Из ТестовыйСлучай.Аннотации Цикл

		Если СтрНайти(Нрег(Аннотация.Имя), ИмяАннотация) > 0 Тогда
			ВхМассив.Добавить(ТестовыйСлучай.Имя);
		КонецЕсли;

	КонецЦикла;

КонецПроцедуры

Процедура Инициализация()

	Лог = Логирование.ПолучитьЛог(ИмяЛога());

	ВыводитьОшибкиПодробно = ПолучитьПеременнуюСреды("TESTRUNNER_VERBOSE") = "1";

	МенеджерВременныхФайлов = Новый МенеджерВременныхФайлов;

	Пути = Новый Массив;
	НаборТестов = Новый Массив;
	Рефлектор = Новый Рефлектор;

	ЗначенияСостоянияТестов();
	ФорматыЛогФайла();
	СоздатьСтруктуруПараметровЗапуска();

	РезультатТестирования = ЗначенияСостоянияТестов.НеВыполнялся;
	ФорматЛогФайла = ФорматыЛогФайла.JUnit;

	ИспользоватьСборСтатистикиСкриптовOnescript = Ложь;
	КаталогСбораСтатистики = Неопределено;
КонецПроцедуры

Инициализация();
